//------------------------------------------------------------------------------
//
// Copyright (c) 1999-2005  Matt Brunk  <info@smartcache.net>
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License VERSION 2 as
// published by the Free Software Foundation.  You are not allowed to
// use any other version of the license; unless you got the explicit
// permission from the author to do so.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
//------------------------------------------------------------------------------
// SmartCardDlg.h : header file
//

#if !defined(AFX_SMARTCARDDLG_H__A1E30461_A99C_47D3_9491_124778F1BF4F__INCLUDED_)
#define AFX_SMARTCARDDLG_H__A1E30461_A99C_47D3_9491_124778F1BF4F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ACOS1.h"

/////////////////////////////////////////////////////////////////////////////
// CSmartCardDlg dialog

class CSmartCardDlg : public CDialog
{

	typedef enum
	{
		COMMAND_ATR,
		COMMAND_START_SESSION,
		COMMAND_SUBMIT_CODE,
		COMMAND_SELECT_FILE,
		COMMAND_READ_FILE,
		COMMAND_SETUP,
		COMMAND_PROGRAM,
		NUM_COMMANDS
	} CommandEnum;

// Construction
public:
	CSmartCardDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CSmartCardDlg)
	enum { IDD = IDD_SMARTCARD_DIALOG };
	CButton	m_checkVerbose;
	CButton	m_checkEncrypt;
	CButton	m_checkClear;
	CComboBox	m_comboPort;
	CComboBox	m_comboBaud;
	CButton	m_BtnProgram;
	CComboBox	m_comboStopBits;
	CEdit	m_EditRemaining;
	CEdit	m_EditCurrent;
	CEdit	m_EditOut;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSmartCardDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CSmartCardDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnButtonAtr();
	afx_msg void OnButtonStartSession();
	afx_msg void OnButtonSubmitCode();
	afx_msg void OnButtonSelectFile();
	afx_msg void OnButtonReadFile();
	afx_msg void OnButtonSetup();
	afx_msg void OnButtonProgram();
	afx_msg void OnSelchangeComboStopBits();
	afx_msg void OnButtonDumpDcb();
	afx_msg void OnSelchangeComboBaud();
	afx_msg void OnSelchangeComboComPort();
	afx_msg void OnDestroy();
	afx_msg void OnCheckEncrypt();
	afx_msg void OnCheckVerbose();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	void	AppendText(LPCTSTR Text);
	void	ClearOutput();
	void	DispatchCommand(CommandEnum command);

	bool	DoATR();
	void	DoStartSession();
	bool	DoSubmitCode();
	bool	DoSelectFile();
	void	DoReadFile();
	void	DoSetup();
	void	DoProgram();


	HICON			m_hSmallIcon;
	CACOS1			m_acos1;
	CFont			m_font;
	unsigned long	m_first;
	unsigned long	m_last;
	int				m_iPort;
	int				m_iBaud;

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SMARTCARDDLG_H__A1E30461_A99C_47D3_9491_124778F1BF4F__INCLUDED_)
